unit schEmpresasClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Empresas = '{BDE24289-FA14-4BFD-90FC-C75CDA2903B4}';
  RID_EmpresasDatosBanco = '{B38F881C-BE9D-4956-BC5B-06C922A088A8}';
  RID_Empresas_Refresh = '{74AFE46D-F556-467E-A6AE-1B30229DB923}';
  RID_EmpresasDatosBanco_Refresh = '{A43716FA-0A11-4A8F-9FFA-9DF825914C22}';

  { Data table names }
  nme_Empresas = 'Empresas';
  nme_EmpresasDatosBanco = 'EmpresasDatosBanco';
  nme_Empresas_Refresh = 'Empresas_Refresh';
  nme_EmpresasDatosBanco_Refresh = 'EmpresasDatosBanco_Refresh';

  { Empresas fields }
  fld_EmpresasID = 'ID';
  fld_EmpresasNIF_CIF = 'NIF_CIF';
  fld_EmpresasNOMBRE = 'NOMBRE';
  fld_EmpresasRAZON_SOCIAL = 'RAZON_SOCIAL';
  fld_EmpresasCALLE = 'CALLE';
  fld_EmpresasPOBLACION = 'POBLACION';
  fld_EmpresasPROVINCIA = 'PROVINCIA';
  fld_EmpresasCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_EmpresasTELEFONO_1 = 'TELEFONO_1';
  fld_EmpresasTELEFONO_2 = 'TELEFONO_2';
  fld_EmpresasMOVIL_1 = 'MOVIL_1';
  fld_EmpresasMOVIL_2 = 'MOVIL_2';
  fld_EmpresasFAX = 'FAX';
  fld_EmpresasEMAIL_1 = 'EMAIL_1';
  fld_EmpresasEMAIL_2 = 'EMAIL_2';
  fld_EmpresasPAGINA_WEB = 'PAGINA_WEB';
  fld_EmpresasNOTAS = 'NOTAS';
  fld_EmpresasFECHA_ALTA = 'FECHA_ALTA';
  fld_EmpresasFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_EmpresasUSUARIO = 'USUARIO';
  fld_EmpresasLOGOTIPO = 'LOGOTIPO';
  fld_EmpresasREGISTRO_MERCANTIL = 'REGISTRO_MERCANTIL';
  fld_EmpresasIVA = 'IVA';

  { Empresas field indexes }
  idx_EmpresasID = 0;
  idx_EmpresasNIF_CIF = 1;
  idx_EmpresasNOMBRE = 2;
  idx_EmpresasRAZON_SOCIAL = 3;
  idx_EmpresasCALLE = 4;
  idx_EmpresasPOBLACION = 5;
  idx_EmpresasPROVINCIA = 6;
  idx_EmpresasCODIGO_POSTAL = 7;
  idx_EmpresasTELEFONO_1 = 8;
  idx_EmpresasTELEFONO_2 = 9;
  idx_EmpresasMOVIL_1 = 10;
  idx_EmpresasMOVIL_2 = 11;
  idx_EmpresasFAX = 12;
  idx_EmpresasEMAIL_1 = 13;
  idx_EmpresasEMAIL_2 = 14;
  idx_EmpresasPAGINA_WEB = 15;
  idx_EmpresasNOTAS = 16;
  idx_EmpresasFECHA_ALTA = 17;
  idx_EmpresasFECHA_MODIFICACION = 18;
  idx_EmpresasUSUARIO = 19;
  idx_EmpresasLOGOTIPO = 20;
  idx_EmpresasREGISTRO_MERCANTIL = 21;
  idx_EmpresasIVA = 22;

  { EmpresasDatosBanco fields }
  fld_EmpresasDatosBancoID = 'ID';
  fld_EmpresasDatosBancoID_EMPRESA = 'ID_EMPRESA';
  fld_EmpresasDatosBancoNOMBRE = 'NOMBRE';
  fld_EmpresasDatosBancoENTIDAD = 'ENTIDAD';
  fld_EmpresasDatosBancoSUCURSAL = 'SUCURSAL';
  fld_EmpresasDatosBancoDC = 'DC';
  fld_EmpresasDatosBancoCUENTA = 'CUENTA';
  fld_EmpresasDatosBancoSUFIJO_N19 = 'SUFIJO_N19';
  fld_EmpresasDatosBancoSUFIJO_N58 = 'SUFIJO_N58';

  { EmpresasDatosBanco field indexes }
  idx_EmpresasDatosBancoID = 0;
  idx_EmpresasDatosBancoID_EMPRESA = 1;
  idx_EmpresasDatosBancoNOMBRE = 2;
  idx_EmpresasDatosBancoENTIDAD = 3;
  idx_EmpresasDatosBancoSUCURSAL = 4;
  idx_EmpresasDatosBancoDC = 5;
  idx_EmpresasDatosBancoCUENTA = 6;
  idx_EmpresasDatosBancoSUFIJO_N19 = 7;
  idx_EmpresasDatosBancoSUFIJO_N58 = 8;

  { Empresas_Refresh fields }
  fld_Empresas_RefreshID = 'ID';
  fld_Empresas_RefreshNIF_CIF = 'NIF_CIF';
  fld_Empresas_RefreshNOMBRE = 'NOMBRE';
  fld_Empresas_RefreshRAZON_SOCIAL = 'RAZON_SOCIAL';
  fld_Empresas_RefreshCALLE = 'CALLE';
  fld_Empresas_RefreshPOBLACION = 'POBLACION';
  fld_Empresas_RefreshPROVINCIA = 'PROVINCIA';
  fld_Empresas_RefreshCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_Empresas_RefreshTELEFONO_1 = 'TELEFONO_1';
  fld_Empresas_RefreshTELEFONO_2 = 'TELEFONO_2';
  fld_Empresas_RefreshMOVIL_1 = 'MOVIL_1';
  fld_Empresas_RefreshMOVIL_2 = 'MOVIL_2';
  fld_Empresas_RefreshFAX = 'FAX';
  fld_Empresas_RefreshEMAIL_1 = 'EMAIL_1';
  fld_Empresas_RefreshEMAIL_2 = 'EMAIL_2';
  fld_Empresas_RefreshPAGINA_WEB = 'PAGINA_WEB';
  fld_Empresas_RefreshNOTAS = 'NOTAS';
  fld_Empresas_RefreshFECHA_ALTA = 'FECHA_ALTA';
  fld_Empresas_RefreshFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_Empresas_RefreshUSUARIO = 'USUARIO';
  fld_Empresas_RefreshLOGOTIPO = 'LOGOTIPO';
  fld_Empresas_RefreshREGISTRO_MERCANTIL = 'REGISTRO_MERCANTIL';
  fld_Empresas_RefreshIVA = 'IVA';

  { Empresas_Refresh field indexes }
  idx_Empresas_RefreshID = 0;
  idx_Empresas_RefreshNIF_CIF = 1;
  idx_Empresas_RefreshNOMBRE = 2;
  idx_Empresas_RefreshRAZON_SOCIAL = 3;
  idx_Empresas_RefreshCALLE = 4;
  idx_Empresas_RefreshPOBLACION = 5;
  idx_Empresas_RefreshPROVINCIA = 6;
  idx_Empresas_RefreshCODIGO_POSTAL = 7;
  idx_Empresas_RefreshTELEFONO_1 = 8;
  idx_Empresas_RefreshTELEFONO_2 = 9;
  idx_Empresas_RefreshMOVIL_1 = 10;
  idx_Empresas_RefreshMOVIL_2 = 11;
  idx_Empresas_RefreshFAX = 12;
  idx_Empresas_RefreshEMAIL_1 = 13;
  idx_Empresas_RefreshEMAIL_2 = 14;
  idx_Empresas_RefreshPAGINA_WEB = 15;
  idx_Empresas_RefreshNOTAS = 16;
  idx_Empresas_RefreshFECHA_ALTA = 17;
  idx_Empresas_RefreshFECHA_MODIFICACION = 18;
  idx_Empresas_RefreshUSUARIO = 19;
  idx_Empresas_RefreshLOGOTIPO = 20;
  idx_Empresas_RefreshREGISTRO_MERCANTIL = 21;
  idx_Empresas_RefreshIVA = 22;

  { EmpresasDatosBanco_Refresh fields }
  fld_EmpresasDatosBanco_RefreshID = 'ID';
  fld_EmpresasDatosBanco_RefreshID_EMPRESA = 'ID_EMPRESA';
  fld_EmpresasDatosBanco_RefreshNOMBRE = 'NOMBRE';
  fld_EmpresasDatosBanco_RefreshENTIDAD = 'ENTIDAD';
  fld_EmpresasDatosBanco_RefreshSUCURSAL = 'SUCURSAL';
  fld_EmpresasDatosBanco_RefreshDC = 'DC';
  fld_EmpresasDatosBanco_RefreshCUENTA = 'CUENTA';
  fld_EmpresasDatosBanco_RefreshSUFIJO_N19 = 'SUFIJO_N19';
  fld_EmpresasDatosBanco_RefreshSUFIJO_N58 = 'SUFIJO_N58';

  { EmpresasDatosBanco_Refresh field indexes }
  idx_EmpresasDatosBanco_RefreshID = 0;
  idx_EmpresasDatosBanco_RefreshID_EMPRESA = 1;
  idx_EmpresasDatosBanco_RefreshNOMBRE = 2;
  idx_EmpresasDatosBanco_RefreshENTIDAD = 3;
  idx_EmpresasDatosBanco_RefreshSUCURSAL = 4;
  idx_EmpresasDatosBanco_RefreshDC = 5;
  idx_EmpresasDatosBanco_RefreshCUENTA = 6;
  idx_EmpresasDatosBanco_RefreshSUFIJO_N19 = 7;
  idx_EmpresasDatosBanco_RefreshSUFIJO_N58 = 8;

type
  { IEmpresas }
  IEmpresas = interface(IDAStronglyTypedDataTable)
  ['{F5A4EFC5-47CF-4091-B7EA-B1F6F93195F5}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetRAZON_SOCIALValue: String;
    procedure SetRAZON_SOCIALValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetTELEFONO_1Value: String;
    procedure SetTELEFONO_1Value(const aValue: String);
    function GetTELEFONO_2Value: String;
    procedure SetTELEFONO_2Value(const aValue: String);
    function GetMOVIL_1Value: String;
    procedure SetMOVIL_1Value(const aValue: String);
    function GetMOVIL_2Value: String;
    procedure SetMOVIL_2Value(const aValue: String);
    function GetFAXValue: String;
    procedure SetFAXValue(const aValue: String);
    function GetEMAIL_1Value: String;
    procedure SetEMAIL_1Value(const aValue: String);
    function GetEMAIL_2Value: String;
    procedure SetEMAIL_2Value(const aValue: String);
    function GetPAGINA_WEBValue: String;
    procedure SetPAGINA_WEBValue(const aValue: String);
    function GetNOTASValue: IROStrings;
    procedure SetNOTASValue(const aValue: IROStrings);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetLOGOTIPOValue: IROStream;
    procedure SetLOGOTIPOValue(const aValue: IROStream);
    function GetREGISTRO_MERCANTILValue: String;
    procedure SetREGISTRO_MERCANTILValue(const aValue: String);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property RAZON_SOCIAL: String read GetRAZON_SOCIALValue write SetRAZON_SOCIALValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property TELEFONO_1: String read GetTELEFONO_1Value write SetTELEFONO_1Value;
    property TELEFONO_2: String read GetTELEFONO_2Value write SetTELEFONO_2Value;
    property MOVIL_1: String read GetMOVIL_1Value write SetMOVIL_1Value;
    property MOVIL_2: String read GetMOVIL_2Value write SetMOVIL_2Value;
    property FAX: String read GetFAXValue write SetFAXValue;
    property EMAIL_1: String read GetEMAIL_1Value write SetEMAIL_1Value;
    property EMAIL_2: String read GetEMAIL_2Value write SetEMAIL_2Value;
    property PAGINA_WEB: String read GetPAGINA_WEBValue write SetPAGINA_WEBValue;
    property NOTAS: IROStrings read GetNOTASValue write SetNOTASValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property LOGOTIPO: IROStream read GetLOGOTIPOValue write SetLOGOTIPOValue;
    property REGISTRO_MERCANTIL: String read GetREGISTRO_MERCANTILValue write SetREGISTRO_MERCANTILValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
  end;

  { TEmpresasDataTableRules }
  TEmpresasDataTableRules = class(TDADataTableRules, IEmpresas)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetRAZON_SOCIALValue: String; virtual;
    procedure SetRAZON_SOCIALValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetTELEFONO_1Value: String; virtual;
    procedure SetTELEFONO_1Value(const aValue: String); virtual;
    function GetTELEFONO_2Value: String; virtual;
    procedure SetTELEFONO_2Value(const aValue: String); virtual;
    function GetMOVIL_1Value: String; virtual;
    procedure SetMOVIL_1Value(const aValue: String); virtual;
    function GetMOVIL_2Value: String; virtual;
    procedure SetMOVIL_2Value(const aValue: String); virtual;
    function GetFAXValue: String; virtual;
    procedure SetFAXValue(const aValue: String); virtual;
    function GetEMAIL_1Value: String; virtual;
    procedure SetEMAIL_1Value(const aValue: String); virtual;
    function GetEMAIL_2Value: String; virtual;
    procedure SetEMAIL_2Value(const aValue: String); virtual;
    function GetPAGINA_WEBValue: String; virtual;
    procedure SetPAGINA_WEBValue(const aValue: String); virtual;
    function GetNOTASValue: IROStrings; virtual;
    procedure SetNOTASValue(const aValue: IROStrings); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetLOGOTIPOValue: IROStream; virtual;
    procedure SetLOGOTIPOValue(const aValue: IROStream); virtual;
    function GetREGISTRO_MERCANTILValue: String; virtual;
    procedure SetREGISTRO_MERCANTILValue(const aValue: String); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property RAZON_SOCIAL: String read GetRAZON_SOCIALValue write SetRAZON_SOCIALValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property TELEFONO_1: String read GetTELEFONO_1Value write SetTELEFONO_1Value;
    property TELEFONO_2: String read GetTELEFONO_2Value write SetTELEFONO_2Value;
    property MOVIL_1: String read GetMOVIL_1Value write SetMOVIL_1Value;
    property MOVIL_2: String read GetMOVIL_2Value write SetMOVIL_2Value;
    property FAX: String read GetFAXValue write SetFAXValue;
    property EMAIL_1: String read GetEMAIL_1Value write SetEMAIL_1Value;
    property EMAIL_2: String read GetEMAIL_2Value write SetEMAIL_2Value;
    property PAGINA_WEB: String read GetPAGINA_WEBValue write SetPAGINA_WEBValue;
    property NOTAS: IROStrings read GetNOTASValue write SetNOTASValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property LOGOTIPO: IROStream read GetLOGOTIPOValue write SetLOGOTIPOValue;
    property REGISTRO_MERCANTIL: String read GetREGISTRO_MERCANTILValue write SetREGISTRO_MERCANTILValue;
    property IVA: Float read GetIVAValue write SetIVAValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IEmpresasDatosBanco }
  IEmpresasDatosBanco = interface(IDAStronglyTypedDataTable)
  ['{83F8EA10-9660-49FD-8A99-6C9775B435F7}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetENTIDADValue: String;
    procedure SetENTIDADValue(const aValue: String);
    function GetSUCURSALValue: String;
    procedure SetSUCURSALValue(const aValue: String);
    function GetDCValue: String;
    procedure SetDCValue(const aValue: String);
    function GetCUENTAValue: String;
    procedure SetCUENTAValue(const aValue: String);
    function GetSUFIJO_N19Value: String;
    procedure SetSUFIJO_N19Value(const aValue: String);
    function GetSUFIJO_N58Value: String;
    procedure SetSUFIJO_N58Value(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property ENTIDAD: String read GetENTIDADValue write SetENTIDADValue;
    property SUCURSAL: String read GetSUCURSALValue write SetSUCURSALValue;
    property DC: String read GetDCValue write SetDCValue;
    property CUENTA: String read GetCUENTAValue write SetCUENTAValue;
    property SUFIJO_N19: String read GetSUFIJO_N19Value write SetSUFIJO_N19Value;
    property SUFIJO_N58: String read GetSUFIJO_N58Value write SetSUFIJO_N58Value;
  end;

  { TEmpresasDatosBancoDataTableRules }
  TEmpresasDatosBancoDataTableRules = class(TDADataTableRules, IEmpresasDatosBanco)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetENTIDADValue: String; virtual;
    procedure SetENTIDADValue(const aValue: String); virtual;
    function GetSUCURSALValue: String; virtual;
    procedure SetSUCURSALValue(const aValue: String); virtual;
    function GetDCValue: String; virtual;
    procedure SetDCValue(const aValue: String); virtual;
    function GetCUENTAValue: String; virtual;
    procedure SetCUENTAValue(const aValue: String); virtual;
    function GetSUFIJO_N19Value: String; virtual;
    procedure SetSUFIJO_N19Value(const aValue: String); virtual;
    function GetSUFIJO_N58Value: String; virtual;
    procedure SetSUFIJO_N58Value(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property ENTIDAD: String read GetENTIDADValue write SetENTIDADValue;
    property SUCURSAL: String read GetSUCURSALValue write SetSUCURSALValue;
    property DC: String read GetDCValue write SetDCValue;
    property CUENTA: String read GetCUENTAValue write SetCUENTAValue;
    property SUFIJO_N19: String read GetSUFIJO_N19Value write SetSUFIJO_N19Value;
    property SUFIJO_N58: String read GetSUFIJO_N58Value write SetSUFIJO_N58Value;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IEmpresas_Refresh }
  IEmpresas_Refresh = interface(IDAStronglyTypedDataTable)
  ['{F4E3D225-DEB3-4ADD-BA79-2845247B3A3A}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetRAZON_SOCIALValue: String;
    procedure SetRAZON_SOCIALValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetTELEFONO_1Value: String;
    procedure SetTELEFONO_1Value(const aValue: String);
    function GetTELEFONO_2Value: String;
    procedure SetTELEFONO_2Value(const aValue: String);
    function GetMOVIL_1Value: String;
    procedure SetMOVIL_1Value(const aValue: String);
    function GetMOVIL_2Value: String;
    procedure SetMOVIL_2Value(const aValue: String);
    function GetFAXValue: String;
    procedure SetFAXValue(const aValue: String);
    function GetEMAIL_1Value: String;
    procedure SetEMAIL_1Value(const aValue: String);
    function GetEMAIL_2Value: String;
    procedure SetEMAIL_2Value(const aValue: String);
    function GetPAGINA_WEBValue: String;
    procedure SetPAGINA_WEBValue(const aValue: String);
    function GetNOTASValue: IROStrings;
    procedure SetNOTASValue(const aValue: IROStrings);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetLOGOTIPOValue: IROStream;
    procedure SetLOGOTIPOValue(const aValue: IROStream);
    function GetREGISTRO_MERCANTILValue: String;
    procedure SetREGISTRO_MERCANTILValue(const aValue: String);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property RAZON_SOCIAL: String read GetRAZON_SOCIALValue write SetRAZON_SOCIALValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property TELEFONO_1: String read GetTELEFONO_1Value write SetTELEFONO_1Value;
    property TELEFONO_2: String read GetTELEFONO_2Value write SetTELEFONO_2Value;
    property MOVIL_1: String read GetMOVIL_1Value write SetMOVIL_1Value;
    property MOVIL_2: String read GetMOVIL_2Value write SetMOVIL_2Value;
    property FAX: String read GetFAXValue write SetFAXValue;
    property EMAIL_1: String read GetEMAIL_1Value write SetEMAIL_1Value;
    property EMAIL_2: String read GetEMAIL_2Value write SetEMAIL_2Value;
    property PAGINA_WEB: String read GetPAGINA_WEBValue write SetPAGINA_WEBValue;
    property NOTAS: IROStrings read GetNOTASValue write SetNOTASValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property LOGOTIPO: IROStream read GetLOGOTIPOValue write SetLOGOTIPOValue;
    property REGISTRO_MERCANTIL: String read GetREGISTRO_MERCANTILValue write SetREGISTRO_MERCANTILValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
  end;

  { TEmpresas_RefreshDataTableRules }
  TEmpresas_RefreshDataTableRules = class(TDADataTableRules, IEmpresas_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetRAZON_SOCIALValue: String; virtual;
    procedure SetRAZON_SOCIALValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetTELEFONO_1Value: String; virtual;
    procedure SetTELEFONO_1Value(const aValue: String); virtual;
    function GetTELEFONO_2Value: String; virtual;
    procedure SetTELEFONO_2Value(const aValue: String); virtual;
    function GetMOVIL_1Value: String; virtual;
    procedure SetMOVIL_1Value(const aValue: String); virtual;
    function GetMOVIL_2Value: String; virtual;
    procedure SetMOVIL_2Value(const aValue: String); virtual;
    function GetFAXValue: String; virtual;
    procedure SetFAXValue(const aValue: String); virtual;
    function GetEMAIL_1Value: String; virtual;
    procedure SetEMAIL_1Value(const aValue: String); virtual;
    function GetEMAIL_2Value: String; virtual;
    procedure SetEMAIL_2Value(const aValue: String); virtual;
    function GetPAGINA_WEBValue: String; virtual;
    procedure SetPAGINA_WEBValue(const aValue: String); virtual;
    function GetNOTASValue: IROStrings; virtual;
    procedure SetNOTASValue(const aValue: IROStrings); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetLOGOTIPOValue: IROStream; virtual;
    procedure SetLOGOTIPOValue(const aValue: IROStream); virtual;
    function GetREGISTRO_MERCANTILValue: String; virtual;
    procedure SetREGISTRO_MERCANTILValue(const aValue: String); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property RAZON_SOCIAL: String read GetRAZON_SOCIALValue write SetRAZON_SOCIALValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property TELEFONO_1: String read GetTELEFONO_1Value write SetTELEFONO_1Value;
    property TELEFONO_2: String read GetTELEFONO_2Value write SetTELEFONO_2Value;
    property MOVIL_1: String read GetMOVIL_1Value write SetMOVIL_1Value;
    property MOVIL_2: String read GetMOVIL_2Value write SetMOVIL_2Value;
    property FAX: String read GetFAXValue write SetFAXValue;
    property EMAIL_1: String read GetEMAIL_1Value write SetEMAIL_1Value;
    property EMAIL_2: String read GetEMAIL_2Value write SetEMAIL_2Value;
    property PAGINA_WEB: String read GetPAGINA_WEBValue write SetPAGINA_WEBValue;
    property NOTAS: IROStrings read GetNOTASValue write SetNOTASValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property LOGOTIPO: IROStream read GetLOGOTIPOValue write SetLOGOTIPOValue;
    property REGISTRO_MERCANTIL: String read GetREGISTRO_MERCANTILValue write SetREGISTRO_MERCANTILValue;
    property IVA: Float read GetIVAValue write SetIVAValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IEmpresasDatosBanco_Refresh }
  IEmpresasDatosBanco_Refresh = interface(IDAStronglyTypedDataTable)
  ['{15A7C527-4B34-4012-8FCB-215C4EFDD4FA}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetENTIDADValue: String;
    procedure SetENTIDADValue(const aValue: String);
    function GetSUCURSALValue: String;
    procedure SetSUCURSALValue(const aValue: String);
    function GetDCValue: String;
    procedure SetDCValue(const aValue: String);
    function GetCUENTAValue: String;
    procedure SetCUENTAValue(const aValue: String);
    function GetSUFIJO_N19Value: String;
    procedure SetSUFIJO_N19Value(const aValue: String);
    function GetSUFIJO_N58Value: String;
    procedure SetSUFIJO_N58Value(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property ENTIDAD: String read GetENTIDADValue write SetENTIDADValue;
    property SUCURSAL: String read GetSUCURSALValue write SetSUCURSALValue;
    property DC: String read GetDCValue write SetDCValue;
    property CUENTA: String read GetCUENTAValue write SetCUENTAValue;
    property SUFIJO_N19: String read GetSUFIJO_N19Value write SetSUFIJO_N19Value;
    property SUFIJO_N58: String read GetSUFIJO_N58Value write SetSUFIJO_N58Value;
  end;

  { TEmpresasDatosBanco_RefreshDataTableRules }
  TEmpresasDatosBanco_RefreshDataTableRules = class(TDADataTableRules, IEmpresasDatosBanco_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetENTIDADValue: String; virtual;
    procedure SetENTIDADValue(const aValue: String); virtual;
    function GetSUCURSALValue: String; virtual;
    procedure SetSUCURSALValue(const aValue: String); virtual;
    function GetDCValue: String; virtual;
    procedure SetDCValue(const aValue: String); virtual;
    function GetCUENTAValue: String; virtual;
    procedure SetCUENTAValue(const aValue: String); virtual;
    function GetSUFIJO_N19Value: String; virtual;
    procedure SetSUFIJO_N19Value(const aValue: String); virtual;
    function GetSUFIJO_N58Value: String; virtual;
    procedure SetSUFIJO_N58Value(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property ENTIDAD: String read GetENTIDADValue write SetENTIDADValue;
    property SUCURSAL: String read GetSUCURSALValue write SetSUCURSALValue;
    property DC: String read GetDCValue write SetDCValue;
    property CUENTA: String read GetCUENTAValue write SetCUENTAValue;
    property SUFIJO_N19: String read GetSUFIJO_N19Value write SetSUFIJO_N19Value;
    property SUFIJO_N58: String read GetSUFIJO_N58Value write SetSUFIJO_N58Value;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TEmpresasDataTableRules }
constructor TEmpresasDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TEmpresasDataTableRules.Destroy;
begin
  inherited;
end;

function TEmpresasDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_EmpresasID].AsInteger;
end;

procedure TEmpresasDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_EmpresasID].AsInteger := aValue;
end;

function TEmpresasDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_EmpresasNIF_CIF].AsString;
end;

procedure TEmpresasDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasNIF_CIF].AsString := aValue;
end;

function TEmpresasDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_EmpresasNOMBRE].AsString;
end;

procedure TEmpresasDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasNOMBRE].AsString := aValue;
end;

function TEmpresasDataTableRules.GetRAZON_SOCIALValue: String;
begin
  result := DataTable.Fields[idx_EmpresasRAZON_SOCIAL].AsString;
end;

procedure TEmpresasDataTableRules.SetRAZON_SOCIALValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasRAZON_SOCIAL].AsString := aValue;
end;

function TEmpresasDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_EmpresasCALLE].AsString;
end;

procedure TEmpresasDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasCALLE].AsString := aValue;
end;

function TEmpresasDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_EmpresasPOBLACION].AsString;
end;

procedure TEmpresasDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasPOBLACION].AsString := aValue;
end;

function TEmpresasDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_EmpresasPROVINCIA].AsString;
end;

procedure TEmpresasDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasPROVINCIA].AsString := aValue;
end;

function TEmpresasDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_EmpresasCODIGO_POSTAL].AsString;
end;

procedure TEmpresasDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasCODIGO_POSTAL].AsString := aValue;
end;

function TEmpresasDataTableRules.GetTELEFONO_1Value: String;
begin
  result := DataTable.Fields[idx_EmpresasTELEFONO_1].AsString;
end;

procedure TEmpresasDataTableRules.SetTELEFONO_1Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasTELEFONO_1].AsString := aValue;
end;

function TEmpresasDataTableRules.GetTELEFONO_2Value: String;
begin
  result := DataTable.Fields[idx_EmpresasTELEFONO_2].AsString;
end;

procedure TEmpresasDataTableRules.SetTELEFONO_2Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasTELEFONO_2].AsString := aValue;
end;

function TEmpresasDataTableRules.GetMOVIL_1Value: String;
begin
  result := DataTable.Fields[idx_EmpresasMOVIL_1].AsString;
end;

procedure TEmpresasDataTableRules.SetMOVIL_1Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasMOVIL_1].AsString := aValue;
end;

function TEmpresasDataTableRules.GetMOVIL_2Value: String;
begin
  result := DataTable.Fields[idx_EmpresasMOVIL_2].AsString;
end;

procedure TEmpresasDataTableRules.SetMOVIL_2Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasMOVIL_2].AsString := aValue;
end;

function TEmpresasDataTableRules.GetFAXValue: String;
begin
  result := DataTable.Fields[idx_EmpresasFAX].AsString;
end;

procedure TEmpresasDataTableRules.SetFAXValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasFAX].AsString := aValue;
end;

function TEmpresasDataTableRules.GetEMAIL_1Value: String;
begin
  result := DataTable.Fields[idx_EmpresasEMAIL_1].AsString;
end;

procedure TEmpresasDataTableRules.SetEMAIL_1Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasEMAIL_1].AsString := aValue;
end;

function TEmpresasDataTableRules.GetEMAIL_2Value: String;
begin
  result := DataTable.Fields[idx_EmpresasEMAIL_2].AsString;
end;

procedure TEmpresasDataTableRules.SetEMAIL_2Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasEMAIL_2].AsString := aValue;
end;

function TEmpresasDataTableRules.GetPAGINA_WEBValue: String;
begin
  result := DataTable.Fields[idx_EmpresasPAGINA_WEB].AsString;
end;

procedure TEmpresasDataTableRules.SetPAGINA_WEBValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasPAGINA_WEB].AsString := aValue;
end;

function TEmpresasDataTableRules.GetNOTASValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_EmpresasNOTAS].AsString;
end;

procedure TEmpresasDataTableRules.SetNOTASValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_EmpresasNOTAS].AsString := aValue.Text;
end;

function TEmpresasDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_EmpresasFECHA_ALTA].AsDateTime;
end;

procedure TEmpresasDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_EmpresasFECHA_ALTA].AsDateTime := aValue;
end;

function TEmpresasDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_EmpresasFECHA_MODIFICACION].AsDateTime;
end;

procedure TEmpresasDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_EmpresasFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TEmpresasDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_EmpresasUSUARIO].AsString;
end;

procedure TEmpresasDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasUSUARIO].AsString := aValue;
end;

function TEmpresasDataTableRules.GetLOGOTIPOValue: IROStream;
begin
  result := NewROStream();
  DataTable.Fields[idx_EmpresasLOGOTIPO].SaveToStream(result);
end;

procedure TEmpresasDataTableRules.SetLOGOTIPOValue(const aValue: IROStream);
begin
  DataTable.Fields[idx_EmpresasLOGOTIPO].LoadFromStream(aValue);
end;

function TEmpresasDataTableRules.GetREGISTRO_MERCANTILValue: String;
begin
  result := DataTable.Fields[idx_EmpresasREGISTRO_MERCANTIL].AsString;
end;

procedure TEmpresasDataTableRules.SetREGISTRO_MERCANTILValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasREGISTRO_MERCANTIL].AsString := aValue;
end;

function TEmpresasDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_EmpresasIVA].AsFloat;
end;

procedure TEmpresasDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_EmpresasIVA].AsFloat := aValue;
end;


{ TEmpresasDatosBancoDataTableRules }
constructor TEmpresasDatosBancoDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TEmpresasDatosBancoDataTableRules.Destroy;
begin
  inherited;
end;

function TEmpresasDatosBancoDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoID].AsInteger;
end;

procedure TEmpresasDatosBancoDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_EmpresasDatosBancoID].AsInteger := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoID_EMPRESA].AsInteger;
end;

procedure TEmpresasDatosBancoDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_EmpresasDatosBancoID_EMPRESA].AsInteger := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoNOMBRE].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoNOMBRE].AsString := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetENTIDADValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoENTIDAD].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetENTIDADValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoENTIDAD].AsString := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetSUCURSALValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoSUCURSAL].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetSUCURSALValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoSUCURSAL].AsString := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetDCValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoDC].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetDCValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoDC].AsString := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetCUENTAValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoCUENTA].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetCUENTAValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoCUENTA].AsString := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetSUFIJO_N19Value: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoSUFIJO_N19].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetSUFIJO_N19Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoSUFIJO_N19].AsString := aValue;
end;

function TEmpresasDatosBancoDataTableRules.GetSUFIJO_N58Value: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBancoSUFIJO_N58].AsString;
end;

procedure TEmpresasDatosBancoDataTableRules.SetSUFIJO_N58Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBancoSUFIJO_N58].AsString := aValue;
end;


{ TEmpresas_RefreshDataTableRules }
constructor TEmpresas_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TEmpresas_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TEmpresas_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_Empresas_RefreshID].AsInteger;
end;

procedure TEmpresas_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Empresas_RefreshID].AsInteger := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshNIF_CIF].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshNIF_CIF].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshNOMBRE].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshNOMBRE].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetRAZON_SOCIALValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshRAZON_SOCIAL].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetRAZON_SOCIALValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshRAZON_SOCIAL].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshCALLE].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshCALLE].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshPOBLACION].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshPOBLACION].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshPROVINCIA].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshPROVINCIA].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshCODIGO_POSTAL].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshCODIGO_POSTAL].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetTELEFONO_1Value: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshTELEFONO_1].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetTELEFONO_1Value(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshTELEFONO_1].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetTELEFONO_2Value: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshTELEFONO_2].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetTELEFONO_2Value(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshTELEFONO_2].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetMOVIL_1Value: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshMOVIL_1].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetMOVIL_1Value(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshMOVIL_1].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetMOVIL_2Value: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshMOVIL_2].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetMOVIL_2Value(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshMOVIL_2].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetFAXValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshFAX].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetFAXValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshFAX].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetEMAIL_1Value: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshEMAIL_1].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetEMAIL_1Value(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshEMAIL_1].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetEMAIL_2Value: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshEMAIL_2].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetEMAIL_2Value(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshEMAIL_2].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetPAGINA_WEBValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshPAGINA_WEB].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetPAGINA_WEBValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshPAGINA_WEB].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetNOTASValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_Empresas_RefreshNOTAS].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetNOTASValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_Empresas_RefreshNOTAS].AsString := aValue.Text;
end;

function TEmpresas_RefreshDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_Empresas_RefreshFECHA_ALTA].AsDateTime;
end;

procedure TEmpresas_RefreshDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Empresas_RefreshFECHA_ALTA].AsDateTime := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_Empresas_RefreshFECHA_MODIFICACION].AsDateTime;
end;

procedure TEmpresas_RefreshDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Empresas_RefreshFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshUSUARIO].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshUSUARIO].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetLOGOTIPOValue: IROStream;
begin
  result := NewROStream();
  DataTable.Fields[idx_Empresas_RefreshLOGOTIPO].SaveToStream(result);
end;

procedure TEmpresas_RefreshDataTableRules.SetLOGOTIPOValue(const aValue: IROStream);
begin
  DataTable.Fields[idx_Empresas_RefreshLOGOTIPO].LoadFromStream(aValue);
end;

function TEmpresas_RefreshDataTableRules.GetREGISTRO_MERCANTILValue: String;
begin
  result := DataTable.Fields[idx_Empresas_RefreshREGISTRO_MERCANTIL].AsString;
end;

procedure TEmpresas_RefreshDataTableRules.SetREGISTRO_MERCANTILValue(const aValue: String);
begin
  DataTable.Fields[idx_Empresas_RefreshREGISTRO_MERCANTIL].AsString := aValue;
end;

function TEmpresas_RefreshDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_Empresas_RefreshIVA].AsFloat;
end;

procedure TEmpresas_RefreshDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_Empresas_RefreshIVA].AsFloat := aValue;
end;


{ TEmpresasDatosBanco_RefreshDataTableRules }
constructor TEmpresasDatosBanco_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TEmpresasDatosBanco_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshID].AsInteger;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshID].AsInteger := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshID_EMPRESA].AsInteger;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshID_EMPRESA].AsInteger := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshNOMBRE].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshNOMBRE].AsString := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetENTIDADValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshENTIDAD].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetENTIDADValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshENTIDAD].AsString := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetSUCURSALValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshSUCURSAL].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetSUCURSALValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshSUCURSAL].AsString := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetDCValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshDC].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetDCValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshDC].AsString := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetCUENTAValue: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshCUENTA].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetCUENTAValue(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshCUENTA].AsString := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetSUFIJO_N19Value: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshSUFIJO_N19].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetSUFIJO_N19Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshSUFIJO_N19].AsString := aValue;
end;

function TEmpresasDatosBanco_RefreshDataTableRules.GetSUFIJO_N58Value: String;
begin
  result := DataTable.Fields[idx_EmpresasDatosBanco_RefreshSUFIJO_N58].AsString;
end;

procedure TEmpresasDatosBanco_RefreshDataTableRules.SetSUFIJO_N58Value(const aValue: String);
begin
  DataTable.Fields[idx_EmpresasDatosBanco_RefreshSUFIJO_N58].AsString := aValue;
end;


initialization
  RegisterDataTableRules(RID_Empresas, TEmpresasDataTableRules);
  RegisterDataTableRules(RID_EmpresasDatosBanco, TEmpresasDatosBancoDataTableRules);
  RegisterDataTableRules(RID_Empresas_Refresh, TEmpresas_RefreshDataTableRules);
  RegisterDataTableRules(RID_EmpresasDatosBanco_Refresh, TEmpresasDatosBanco_RefreshDataTableRules);

end.
